rms_init=sqrt(sum(SUP_resp.*SUP_resp))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_init_low=sqrt(sum(SUP_resp(1:91).*SUP_resp(1:91)))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window

PB_SUP=interpol(PB_SUP_import(:,2));
DE_SUP=interpol(DE_SUP_import(:,2));
HPU_SUP=interpol(HPU_SUP_import(:,2));

PB_SUP_d2=interpol(PB_SUP_d2_import);
DE_SUP_d2=interpol(DE_SUP_d2_import);
HPU_SUP_d2=interpol(HPU_SUP_d2_import);

PB_SUP_d6=interpol(PB_SUP_d6_import);
DE_SUP_d6=interpol(DE_SUP_d6_import);
HPU_SUP_d6=interpol(HPU_SUP_d6_import);

RSUP=PB_load.*PB_SUP+DE_load.*DE_SUP+HPU_load.*HPU_SUP;
RSUP_d2=PB_load.*PB_SUP_d2+DE_load.*DE_SUP_d2+HPU_load.*HPU_SUP_d2;
RSUP_d6=PB_load.*PB_SUP_d6+DE_load.*DE_SUP_d6+HPU_load.*HPU_SUP_d6;

rms_current=sqrt(sum(RSUP.*RSUP))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_current_low=sqrt(sum(RSUP(1:91).*RSUP(1:91)))*1000*sqrt(1/1.5)/sqrt(2);
rms_ratio=rms_current/rms_init*100;
rms_ratio_low=rms_current_low/rms_init_low*100;

rms_current_d2=sqrt(sum(RSUP_d2.*RSUP_d2))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_current_low_d2=sqrt(sum(RSUP_d2(1:91).*RSUP_d2(1:91)))*1000*sqrt(1/1.5)/sqrt(2);
rms_ratio_d2=rms_current_d2/rms_init*100;
rms_ratio_low_d2=rms_current_low_d2/rms_init_low*100;

rms_current_d6=sqrt(sum(RSUP_d6.*RSUP_d6))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_current_low_d6=sqrt(sum(RSUP_d6(1:91).*RSUP_d6(1:91)))*1000*sqrt(1/1.5)/sqrt(2);
rms_ratio_d6=rms_current_d6/rms_init*100;
rms_ratio_low_d6=rms_current_low_d6/rms_init_low*100;

%% Plotting
figure(1) 
subplot(3,3,1)
plot(f,PB_load)
xlabel('Frequency [Hz]')
ylabel('F_{PB} [kN]')
axis([2 1000 0 1])

subplot(3,3,2)
plot(f,DE_load)
xlabel('Frequency [Hz]')
ylabel('F_{DE} [kN]')
axis([2 1000 0 50])

subplot(3,3,3)
plot(f,HPU_load)
xlabel('Frequency [Hz]')
ylabel('F_{HPU} [kN]')
axis([2 1000 0 50])

subplot(3,3,4)
plot(f,PB_SUP_d2,'r',f,PB_SUP,'b',f,PB_SUP_d6,'g')
legend('CDR = 2%','CDR = 4% (default)','CDR = 6%')
xlabel('Frequency [Hz]')
ylabel('FRF_{PB} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,5)
plot(f,DE_SUP_d2,'r',f,DE_SUP,'b',f,DE_SUP_d6,'g')
legend('CDR = 2%','CDR = 4% (default)','CDR = 6%')
xlabel('Frequency [Hz]')
ylabel('FRF_{DE} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,6)
plot(f,HPU_SUP_d2,'r',f,HPU_SUP,'b',f,HPU_SUP_d6,'g')
legend('CDR = 2%','CDR = 4% (default)','CDR = 6%')
xlabel('Frequency [Hz]')
ylabel('FRF_{HPU} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,7:9)
plot(f,RSUP_d2,'r',f,RSUP,'b',f,RSUP_d6,'g')
legend('CDR = 2%','CDR = 4% (default)','CDR = 6%')
xlabel('Frequency [Hz]')
ylabel('RMS velocity [m/s]')
axis([2 1000 0 .5e-3])

disp(['CDR=2% : RMS ratio [2-1000]Hz = ' num2str(rms_ratio_d2) '%, and RMS ratio [2-100]Hz = ' num2str(rms_ratio_low_d2) '%'])
disp(['CDR=4% : RMS ratio [2-1000]Hz = ' num2str(rms_ratio) '%, and RMS ratio [2-100]Hz = ' num2str(rms_ratio_low) '%'])
disp(['CDR=6% : RMS ratio [2-1000]Hz = ' num2str(rms_ratio_d6) '%, and RMS ratio [2-100]Hz = ' num2str(rms_ratio_low_d6) '%'])