%Change k5, k6, k7 and k8 (blanc) manually

rms_init=sqrt(sum(SUP_resp.*SUP_resp))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_init_low=sqrt(sum(SUP_resp(1:91).*SUP_resp(1:91)))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window

PB_SUP_v=interpol(PB_SUP_k5_import(:,2));
DE_SUP_v=interpol(DE_SUP_k5_import(:,2));
HPU_SUP_v=interpol(HPU_SUP_k5_import(:,2));


SUP_resp_v=PB_load.*PB_SUP_v+DE_load.*DE_SUP_v+HPU_load.*HPU_SUP_v;
rms_current=sqrt(sum(SUP_resp_v.*SUP_resp_v))*1000*sqrt(1/1.5)/sqrt(2); %Hanning window
rms_current_low=sqrt(sum(SUP_resp_v(1:91).*SUP_resp_v(1:91)))*1000*sqrt(1/1.5)/sqrt(2);
rms_ratio=rms_current/rms_init*100;
rms_ratio_low=rms_current_low/rms_init_low*100;
%% Plotting
figure(3) 
subplot(3,3,1)
plot(f,PB_load)
xlabel('Frequency [Hz]')
ylabel('F_{PB} [kN]')
axis([2 1000 0 1])

subplot(3,3,2)
plot(f,DE_load)
xlabel('Frequency [Hz]')
ylabel('F_{DE} [kN]')
axis([2 1000 0 50])

subplot(3,3,3)
plot(f,HPU_load)
xlabel('Frequency [Hz]')
ylabel('F_{HPU} [kN]')
axis([2 1000 0 50])

subplot(3,3,4)
plot(f,PB_SUP_v)
xlabel('Frequency [Hz]')
ylabel('FRF_{PB} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,5)
plot(f,DE_SUP_v)
xlabel('Frequency [Hz]')
ylabel('FRF_{DE} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,6)
plot(f,HPU_SUP_v)
xlabel('Frequency [Hz]')
ylabel('FRF_{HPU} [m/(s kN)]')
axis([2 1000 0 1e-4])

subplot(3,3,7:9)
plot(f,SUP_resp_v/sqrt(2))
xlabel('Frequency [Hz]')
ylabel('RMS velocity [m/s]')
axis([2 1000 0 .5e-3])

disp(['RMS ratio [2-1000]Hz = ' num2str(rms_ratio) '%, and RMS ratio [2-100]Hz = ' num2str(rms_ratio_low) '%'])