%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  This GUI was made by Thomas Otto Strkson  %
%   as a part of the master thesis at NTNU    %
%                                             %
%  spec2.m need to be in the same folder as   %
%  the GUI in able for it to work properly    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function varargout = TMD_GUI(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TMD_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @TMD_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

%Initializing
function TMD_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
handles.a=0;
handles.b=0.1;
handles.c=0;
handles.m_mult=0;
handles.k_mult=0;
handles.c_mult=0;
handles.valid=ones(1,6);
[f X Y Y2 H A]=spec2(handles.a,handles.b,handles.c);
set(handles.A1,'String',[num2str(A(1)/1000) 'kN'])
set(handles.A2,'String',[num2str(A(2)/1000) 'kN'])
set(handles.A3,'String',[num2str(A(3)/1000) 'kN'])
set(handles.A4,'String',[num2str(A(4)/1000) 'kN'])
set(handles.A5,'String',[num2str(A(5)/1000) 'kN'])
set(handles.A6,'String',[num2str(A(6)/1000) 'kN'])

RMS=norm(Y2,2)/sqrt(2)*1000;
handles.Y2_init=Y2;
handles.RMS_init=RMS;
set(handles.mtext,'String',[num2str(handles.a*59500) ' kg'])
set(handles.a_text,'String',[ 'a= ' num2str(handles.a) ])
set(handles.ktext,'String',[num2str(handles.b*1000) ' MN/m'])
set(handles.b_text,'String',[ 'b= ' num2str(handles.b) ])
set(handles.ctext,'String',[num2str(handles.c/1000) 'kN s/m'])
set(handles.RMStext,'String',['RMS: ' num2str(RMS/handles.RMS_init*100) '%'])

%Plotting
TOP=1E-7;
Y_scale=TOP/max(Y);
bar(X-3,Y.*Y_scale,0.3)
hold on
bar(X+3,Y2.*(Y_scale*2*10^9),0.3,'r')
plot(f,H)
legend('Load','Response','Amplification')
axis([0 1000 0 TOP])
hold off
xlabel('Hz')
ylabel('Amplification')

handles.output = hObject;
guidata(hObject, handles);

function varargout = TMD_GUI_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

%k-slider action
function kslider_Callback(hObject, eventdata, handles)

handles.b=get(hObject,'Value')*10^(-handles.k_mult);
[f X Y Y2 H A]=spec2(handles.a,handles.b,handles.c);
set(handles.A1,'String',[num2str(A(1)/1000) 'kN'])
set(handles.A2,'String',[num2str(A(2)/1000) 'kN'])
set(handles.A3,'String',[num2str(A(3)/1000) 'kN'])
set(handles.A4,'String',[num2str(A(4)/1000) 'kN'])
set(handles.A5,'String',[num2str(A(5)/1000) 'kN'])
set(handles.A6,'String',[num2str(A(6)/1000) 'kN'])
Y=Y.*handles.valid;
Y2=Y2.*handles.valid;
RMS=norm(Y2,2)/sqrt(2)*1000;
set(handles.b_text,'String',[ 'b= ' num2str(handles.b) ])
set(handles.ktext,'String',[num2str(handles.b*1000) ' MN/m'])
set(handles.RMStext,'String',['RMS: ' num2str(RMS/handles.RMS_init*100) '%'])
TOP=1E-7;

%Plotting
Y_scale=TOP/max(Y);
bar(X-3,Y.*Y_scale,0.3)
hold on
bar(X+3,Y2.*(Y_scale*2*10^9),0.3,'r')
plot(f,H)
legend('Load','Response','Amplification')
axis([0 1000 0 TOP])
hold off
xlabel('Hz')
ylabel('Amplification')

handles.output = hObject;
guidata(hObject, handles);

function kslider_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%m-slider action
function mslider_Callback(hObject, eventdata, handles)

handles.a=get(hObject,'Value')*10^(-handles.m_mult);
[f X Y Y2 H A]=spec2(handles.a,handles.b,handles.c);
set(handles.A1,'String',[num2str(A(1)/1000) 'kN'])
set(handles.A2,'String',[num2str(A(2)/1000) 'kN'])
set(handles.A3,'String',[num2str(A(3)/1000) 'kN'])
set(handles.A4,'String',[num2str(A(4)/1000) 'kN'])
set(handles.A5,'String',[num2str(A(5)/1000) 'kN'])
set(handles.A6,'String',[num2str(A(6)/1000) 'kN'])
Y=Y.*handles.valid;
Y2=Y2.*handles.valid;
RMS=norm(Y2,2)/sqrt(2)*1000;
set(handles.a_text,'String',[ 'a= ' num2str(handles.a) ])
set(handles.mtext,'String',[num2str(handles.a*5.95E4) ' kg'])
set(handles.RMStext,'String',['RMS: ' num2str(RMS/handles.RMS_init*100) '%'])
TOP=1E-7;

%Plotting
Y_scale=TOP/max(Y);
bar(X-3,Y.*Y_scale,0.3)
hold on
bar(X+3,Y2.*(Y_scale*2*10^9),0.3,'r')
plot(f,H)
legend('Load','Response','Amplification')
axis([0 1000 0 TOP])
hold off
xlabel('Hz')
ylabel('Amplification')

handles.output = hObject;
guidata(hObject, handles);

function mslider_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

%c-slider action
function cslider_Callback(hObject, eventdata, handles)

handles.c=get(hObject,'Value')*10^(handles.c_mult);
[f X Y Y2 H A]=spec2(handles.a,handles.b,handles.c);
set(handles.A1,'String',[num2str(A(1)/1000) 'kN'])
set(handles.A2,'String',[num2str(A(2)/1000) 'kN'])
set(handles.A3,'String',[num2str(A(3)/1000) 'kN'])
set(handles.A4,'String',[num2str(A(4)/1000) 'kN'])
set(handles.A5,'String',[num2str(A(5)/1000) 'kN'])
set(handles.A6,'String',[num2str(A(6)/1000) 'kN'])
%valid=[get(handles.k1,'Value'),get(handles.k2,'Value'),get(handles.k3,'Value'),get(handles.k4,'Value'),get(handles.k5,'Value')];
Y=Y.*handles.valid;
Y2=Y2.*handles.valid;
RMS=norm(Y2,2)/sqrt(2)*1000;
set(handles.ctext,'String',[num2str(handles.c/1000) ' kN s/m'])
set(handles.RMStext,'String',['RMS: ' num2str(RMS/handles.RMS_init*100) '%'])
TOP=1E-7;

%Plotting
Y_scale=TOP/max(Y);
bar(X-3,Y.*Y_scale,0.3)
hold on
bar(X+3,Y2.*(Y_scale*2*10^9),0.3,'r')
plot(f,H)
legend('Load','Response','Amplification')
axis([0 1000 0 TOP])
hold off
xlabel('Hz')
ylabel('Amplification')

% Choose default command line output for TMD_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

function cslider_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function mbox_Callback(hObject, eventdata, handles)

function mbox_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function kbox_Callback(hObject, eventdata, handles)

function kbox_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function RMSbox_Callback(hObject, eventdata, handles)

function RMSbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to RMSbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function k1_Callback(hObject, eventdata, handles)

handles.valid(1)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;
handles.output = hObject;

guidata(hObject, handles);

function k2_Callback(hObject, eventdata, handles)

handles.valid(2)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;
handles.output = hObject;

guidata(hObject, handles);

function k3_Callback(hObject, eventdata, handles)

handles.valid(3)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;

handles.output = hObject;

guidata(hObject, handles);

function k4_Callback(hObject, eventdata, handles)

handles.valid(4)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;

handles.output = hObject;

guidata(hObject, handles);

function k5_Callback(hObject, eventdata, handles)

handles.valid(5)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;

handles.output = hObject;
guidata(hObject, handles);

function k6_Callback(hObject, eventdata, handles)

handles.valid(6)=get(hObject,'Value');
Y2=handles.Y2_init.*handles.valid;

handles.output = hObject;

guidata(hObject, handles);

function m_mult_slider_Callback(hObject, eventdata, handles)

handles.m_mult=get(hObject,'Value');
set(handles.m_mult_text,'String',['m E' num2str(-handles.m_mult)])

handles.output = hObject;

guidata(hObject, handles);

function m_mult_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to m_mult_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function k_mult_slider_Callback(hObject, eventdata, handles)

handles.k_mult=get(hObject,'Value');
set(handles.k_mult_text,'String',['k E' num2str(-handles.k_mult)])
handles.output = hObject;

guidata(hObject, handles);

function k_mult_slider_CreateFcn(hObject, eventdata, handles)

if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function c_mult_slider_Callback(hObject, eventdata, handles)

handles.c_mult=get(hObject,'Value');
set(handles.c_mult_text,'String',['c E' num2str(handles.c_mult)])

handles.output = hObject;
guidata(hObject, handles);

function c_mult_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_mult_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
